package com.test;

import java.util.Properties;

import org.osgi.framework.Bundle;
import org.osgi.framework.Constants;
import org.osgi.util.tracker.ServiceTracker;
import org.springframework.osgi.test.AbstractConfigurableBundleCreatorTests;
import org.springframework.osgi.test.platform.Platforms;
import org.springframework.osgi.util.OsgiStringUtils;

import com.test.person.service.PersonService;

public class LoadOSGiTestCase extends AbstractConfigurableBundleCreatorTests{

	@Override
	protected String[] getTestBundlesNames() {
		return new String[] { "com.integratingstuff.osgi, com.integratingstuff.osgi.services1, 1.0.0",
				"com.integratingstuff.osgi, com.integratingstuff.osgi.services2, 1.0.0"};
	}
	
	public void testOsgiPlatformStarts() throws Exception {
		System.out.println(bundleContext.getProperty(Constants.FRAMEWORK_VENDOR));
		System.out.println(bundleContext.getProperty(Constants.FRAMEWORK_VERSION));
		System.out.println(bundleContext.getProperty(Constants.FRAMEWORK_EXECUTIONENVIRONMENT));
	}

	public void testOsgiEnvironment() throws Exception {
		Bundle[] bundles = bundleContext.getBundles();
		for (int i = 0; i < bundles.length; i++) {
			System.out.print(OsgiStringUtils.nullSafeName(bundles[i]));
			System.out.print(", ");
		}
	}
	
	public void testRetrieveService() throws Exception {
		Properties props = new Properties();
		props.put("Language", "English");
		
		ServiceTracker accountServiceTracker = new ServiceTracker(bundleContext, PersonService.class.getName(), null);
		accountServiceTracker.open();
		PersonService personService = (PersonService) accountServiceTracker.getService();
		personService.createPersonWithAccount("Steffen", 1000l);
	}
	
	@Override
	protected String getPlatformName() {
		return Platforms.FELIX;
	}
	
}

